
const byte rnum=4;                   //sorok száma
const byte cnum=4;                   //oszlopok száma
const byte rows[rnum]={2,3,4,5};     //a sorvezetékekhez rendelt kimenetek
const byte cols[cnum]={6,7,8,9};     //az oszlopvezetékekhez rendelt bemenetek
const char keyTable[cnum][rnum] = {  //Nyomógombokhoz rendelt kódok
    {'1', '2', '3','A'},
    {'4', '5', '6', 'B'},
    {'7', '8', '9', 'C'},
    {'*', '0', '#', 'D'}};
    
#define KEY_PRESSED() ((!digitalRead(cols[0])) || (!digitalRead(cols[1])) || (!digitalRead(cols[2])) || (!digitalRead(cols[3])))
    
    
//--- Minden sorvezeték alacsony szintre állítása -----
void allRowLow() {
  for(byte i=0; i<rnum; i++) {
    digitalWrite(rows[i],LOW);       //Minden sorvezeték legyen alacsony szintre húzva
  }  
}  

//--- kiválsaztott sorvezeték alacsony szintre állítása -----
void oneRowLow(byte n) {
  for(byte i=0; i<rnum; i++) {
    if(i == n) digitalWrite(rows[i],LOW);
    else digitalWrite(rows[i],HIGH);    
  }
}  

//--- Gomblenyomás figyelése és feldolgozása -------
char keyscan() {
  byte xcol, xrow;
  //-- A lenyomott gombhoz tartozó oszlop meghatározása
  if (!digitalRead(cols[0])) xcol = 0;
  else if (!digitalRead(cols[1])) xcol = 1;
  else if (!digitalRead(cols[2])) xcol = 2;
  else if (!digitalRead(cols[3])) xcol = 3;  
  else return(0);                    //Kilépés: nem történt gomblenyomás
  //-- A lenyomott gombhoz tartozó sor meghatározása
  for (byte xrow=0; xrow < rnum; xrow++) {
    oneRowLow(xrow);                 //egy sorvezeték lehúzása
    if (KEY_PRESSED()) {
      allRowLow();                   //minden sor lehúzása
      return(keyTable[xrow][xcol]);  //Visszatérés az azonosított gomb kódjával
    }
  }  
  allRowLow();                       //minden sor lehúzása
  return(0);                         //Kilépés: sikertelen gomblenyomás azonosítás  
}

void setup() {
  for(byte i=0; i<rnum; i++) {
    pinMode(rows[i],OUTPUT);         //Minden sorvezeték legyen digitális kimenet
    digitalWrite(rows[i],LOW);       //Minden sorvezeték legyen alacsony szintre húzva
  }
  for(byte i=0; i<cnum; i++) {
    pinMode(cols[i],INPUT_PULLUP);   //Minden oszlopvezeték legyen bemenet, belső felhúzással
  }
  Serial.begin(9600);                //UART kimenet inicializálása
}

void loop() {
  delay(20);
  char key = keyscan();
  if(key) {
    if(key == '#') Serial.println(key);
    else Serial.print(key);
    delay(200);
  }  
}


